#! /usr/bin/perl -w
## Outbound stat v0.01 by SeaD (2:5054/84.1)

if (!($outb_dir = $ARGV[0])) { die "usage: $0 <outbound dir>\n" }

$_ = $outb_dir; 

if (s/.+\/([0-9a-z]+)\.pnt$/$1/) {
    $zone = "2";
    $net = hex(substr($_, 0, 4));
    $num = hex(substr($_, 4, 4));
    $node = $zone . ":" . $net . "/" . $num;
} else { $node = "0:0000" }

$debug = 0;
$debug_file = "/tmp/outb.debug";

if ($debug) { open(FDEBUG, ">> " . $debug_file) or die "open($debug_file): $!\n" }

$aerr = 0; $nerr = 0; $oerr = 0;
$pnum = $nnum = $anum = $onum = 0;

opendir(DTMP, "$outb_dir") or die "opendir($outb_dir): $!\n";
@files = readdir(DTMP);
closedir(DTMP);

$dsize = $dnum = 0;
foreach (@files) {
    if (/^\./) { next } $dsize += (stat($outb_dir . "/" . $_))[7]; $dnum++
}

foreach (@files) {
    $file = $_;
    if (!(s/.+([0-9a-f][0-9a-f][0-9a-f][0-9a-f])\.([a-z])lo$/$1 $2/)) { next }
    ($p, $flav) = split; $addr = hex($p);
    $point{$p} = $p; $paddr{$p} = $addr; $aflav{$p} = $flav;
    $afile{$p} = $outb_dir . "/" . $file; $pnum++
}

foreach (@files) {
    if (!(s/.+([0-9a-f][0-9a-f][0-9a-f][0-9a-f])\.([a-z])ut$/$1 $2/)) { next }
    ($p, $flav) = split;
    if (!$point{$p}) { $nerr++; next }
    ($blah, $blah, $blah, $blah, $blah, $blah, $blah, $size,
        $blah, $blah, $blah, $blah, $blah) = stat($outb_dir . "/" . $_);
    if (!$size) { $nerr++; next }
    $nflav{$p} = $flav; $nsize{$p} += $size; $nnum++
}

foreach $p (keys(%point)) {
    open(FLO, "< " . $afile{$p}) or die "open($file): $!\n";
    while (<FLO>) {
        chomp; $file = substr($_, 1);
        if (/.+\.[a-z][a-z][0-9]$/) {
            ($blah, $blah, $blah, $blah, $blah, $blah, $blah, $size,
                $blah, $blah, $ctim, $blah, $blah) = stat($file);
            if (!$size) { $aerr++; next } $ctime{$p} = $ctim; $asize{$p} += $size; $anum++
        } else {
            ($blah, $blah, $blah, $blah, $blah, $blah, $blah, $size,
                $blah, $blah, $blah, $blah, $blah) = stat($file);
            if (!$size) { $oerr++; next } $osize{$p} += $size; $onum++
        }
    }
    close(FLO);
}

printf("%-16s  %-10s  %-10s  %-10s  %-8s  %-8s\n", "= link", "= netmail", "= arcmail", "= other", "= flavor", "= age");
printf("%-16s  %-10s  %-10s  %-10s  %-8s  %-8s\n", "================", "==========", "==========", "==========", "========", "========");

$nall = $aall = $oall = 0; $otime = 2000000000;
foreach $p (sort(keys(%point))) {
    $addr = $node . "." . $paddr{$p};
    $nsiz = $nsize{$p} || 0; $nall += $nsiz;
    $asiz = $asize{$p} || 0; $aall += $asiz;
    $osiz = $osize{$p} || 0; $oall += $osiz;
    if ($aflav{$p} eq "h") { $fh = "H" }
    elsif ($nflav{$p} && ($nflav{$p} eq "h")) { $fh = "H" }
    else { $fh = "-" }
    if ($aflav{$p} eq "o") { $fo = "O" }
    elsif ($nflav{$p} && ($nflav{$p} eq "o")) { $fo = "O" }
    else { $fo = "-" }
    if ($aflav{$p} eq "c") { $fc = "C" }
    elsif ($nflav{$p} && ($nflav{$p} eq "c")) { $fc = "C" }
     else { $fc = "-" }
    if ($aflav{$p} eq "d") { $fd = "D" }
    elsif ($nflav{$p} && ($nflav{$p} eq "d")) { $fd = "D" }
    else { $fd = "-" }
    if ($aflav{$p} eq "i") { $fi = "I" }
    elsif ($nflav{$p} && ($nflav{$p} eq "i")) { $fi = "I" }
    else { $fi = "-" }
    $flav = $fh . $fo . $fc . $fd . $fi;
    $time = $ctime{$p}; if ($time < $otime) { $otime = $time }
    $time = (time() - $time) / 60; $hour = $time / 60; $min = $time % 60;
    if ($hour >= 2) { $age = sprintf("%u hours", $hour)
    } elsif ($hour) { $age = sprintf("one hour")
    } elsif ($min >= 5) { $age = sprintf("%u mins", $min)
    } else { $age = sprintf("up-to-date") }
    printf("%-16s  %10u  %10u  %10u  %-8s  %-8s\n", $addr, $nsiz, $asiz, $osiz, $flav, $age);
}
$otime = (time() - $otime) / 60; $hour = $otime / 60; $min = $otime % 60;
$age = sprintf("%02u:%02u", $hour, $min); $aflav = "HOCDI";
printf("%-16s  %-10s  %-10s  %-10s  %-8s  %-8s\n", "================", "==========", "==========", "==========", "========", "========");
printf("%-16s  %9.2fk  %9.2fk  %9.2fk  %-8s  %-8s\n", "= total", ($nall/1024), ($aall/1024), ($oall/1024), $aflav, $age);
print "\n";

print $pnum . " points, " . $dnum . " files, " . $dsize . " bytes, ";
print "net: " . $nnum . ", arc: " . $anum . ", other: " . $onum . ", ";
print "error: " . ($aerr + $nerr + $oerr) . "\n";

if ($debug) { close(FDEBUG) }
